% See www.strollswithmydog.com/linear-color-transforms
wl = 380:730;
load matlab.mat             %use supplied matlab data file instead of below
% illType = 'D';
% cct = 5300;                                                 %illuminant CCT
% ill = illuminant([illType num2str(cct)],wl)/100;            %needs optprop
% cc24 = xlsread('E:\My Drive\Camera\Data\Reflectance\CC24_Classic_BabelColor30_Pre2015.csv','H2:AQ25')';
% cc24 = interp1(380:10:730,cc24,wl);                             %reflectance
% cmf = csvread('E:\My Drive\Camera\Data\CMF\ciexyz31_1.csv');    %1931 Obs
% cmf = cmf(21:371,2:4);                                          %380:730nm
% ssf = csvread('E:\My Drive\Camera\Data\CFA\D5100.csv');         %D5100
% ssf = interp1(380:5:780,ssf(:,2:4),wl);

xyzn = ill * cmf;
xyzn = xyzn/xyzn(2);
cctDuv(xyzn);

radiance = cc24 .* ill';

xyzRef = radiance' * cmf;
xyzRef = xyzRef/xyzRef(22,2)*0.19;
labRef = xyz2labn(xyzRef,xyzn);

raw = radiance' * ssf;
wbraw = raw ./ sum(ssf .* ill');
wbraw = wbraw/wbraw(22,2)*xyzRef(22,2);

%use 'fminsearch' if you do not have the Optimization Toolbox
[M,M0,de76,de00,k,output] = estimateMatrixWpp(wbraw,xyzRef,xyzn,'fminunc');
%remember: Forward Matrix is M' in this case, xyz = wbraw * M

patches = [1:18 22];  %not to overweight neutrals especially with WPP
disp(['M mean de00 over 19 patches: ' num2str(mean(de00(patches)))])
disp(['M0 mean de00 over 19 patches: ' num2str(...
    mean(deltaE00( xyz2labn(wbraw(patches,:)*M0,xyzn), labRef(patches,:) )))]) 
%mean(deltaE00( xyz2labn(wbraw*FM0,xyzn), labRef ))
(M0/sum(M0(:,2)))'
sum(ans')
